<?php
/*
Plugin Name: Spoiler Button
Description: Adds "[spoiler]Spoiler Text[/spoiler]" Tags
Version: 1.1
Author: ePirat
Author URI: http://www.epirat.de/
*/

# get correct id for plugin
$thisfile=basename(__FILE__, ".php");

# register plugin
register_plugin(
	$thisfile, 
	'Spoiler Button', 	
	'1.1', 		
	'ePirat',
	'http://www.epirat.de/', 
	'Adds [spoiler][/spoiler] (BBCode Style)',
	'plugin',
	'spoiler_button_display'  
);

add_filter('content','spoiler_button_display');
add_action('theme-header','code'); 
# functions
function code(){
echo("<script type=\"text/javascript\">\r\n
				function getElementsByClass(searchClass,node,tag) {\r\n
					var classElements = new Array();\r\n
					if ( node == null )\r\n
					node = document;\r\n
					if ( tag == null )\r\n
					tag = '*';\r\n
					var els = node.getElementsByTagName(tag);\r\n
					var elsLen = els.length;\r\n
					var pattern = new RegExp(\"(^|\\s)\"+searchClass+\"(\\s|$)\");\r\n
					for (i = 0, j = 0; i < elsLen; i++) {\r\n
						if ( pattern.test(els[i].className) ) {\r\n
							classElements[j] = els[i];\r\n
							j++;\r\n
						}\r\n
					}\r\n
					return classElements;\r\n
				}\r\n
				window.onload = function() {\r\n
					var spoilers = getElementsByClass('spoiler');\r\n
					for(x in spoilers) {\r\n
						spoilers[x].getElementsByTagName('p')[0].style.display = 'none';\r\n
						var Ausgabebereich = spoilers[x];\r\n
						var SpoilBtn = document.createElement(\"INPUT\");\r\n
						SpoilBtn.type = 'button';\r\n
						SpoilBtn.value = 'Spoiler';\r\n
						SpoilBtn.onclick = function () {spoiler(this.parentNode);};\r\n
						Ausgabebereich.insertBefore(SpoilBtn, Ausgabebereich.firstChild);\r\n
					}\r\n
				};\r\n

				function spoiler(obj) {\r\n
					var st = obj.getElementsByTagName('p')[0].style;\r\n
					st.display = (st.display == 'none' || st.display == '') ? 'block' : 'none';\r\n
					st.backgroundColor = \"transparent\";\r\n
				}\r\n
			</script>\r\n
			<style type=\"text/css\">\r\n
				<!--\r\n
				div.spoiler p:hover { background-color: #FFF; }\r\n
				div.spoiler p {
					background-color: #333; \r\n
					color: #333;
				}\r\n
				-->\r\n
			</style>\r\n");
}

function spoiler_button_display($content)
{
	$content = preg_replace("/\[spoiler\](.*)\[\/spoiler\]/Usi", "<div class=\"spoiler\"><p>\\1</p></div>", $content);
	return $content;
}
?>